(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('polythene-core-css'), require('polythene-core-icon-button')) :
  typeof define === 'function' && define.amd ? define(['exports', 'polythene-core-css', 'polythene-core-icon-button'], factory) :
  (factory((global.polythene = {}),global['polythene-core-css'],global['polythene-core-icon-button']));
}(this, (function (exports,polytheneCoreCss,polytheneCoreIconButton) { 'use strict';

  var classes = {
    component: "pe-button pe-icon-button",

    // elements
    content: "pe-icon-button__content",

    // states
    compact: "pe-icon-button--compact"
  };

  function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

  var layout = (function (selector, componentVars) {
    return [_defineProperty({}, selector, {
      // don"t set button size to facilitate different icon sizes
      display: "inline-block",
      verticalAlign: "middle",
      cursor: "pointer",
      position: "relative",
      fontSize: "1rem",
      borderRadius: "50%",
      border: "none",

      " .pe-icon-button__content": {
        "line-height": 1,
        padding: componentVars.padding + "px"
      },

      ".pe-icon-button--compact": {
        " .pe-icon-button__content": {
          padding: componentVars.padding_compact + "px"
        }
      }
    })];
  });

  function _defineProperty$1(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

  var style = function style(scopes, selector, componentVars, tint) {
    return [_defineProperty$1({}, scopes.map(function (s) {
      return s + selector;
    }).join(","), {
      color: componentVars["color_" + tint],
      backgroundColor: componentVars["color_" + tint + "_background"] || componentVars["color_background"],
      " .pe-button__wash": {
        opacity: componentVars["color_" + tint + "_wash_opacity"]
      },

      ".pe-button--focus, &.pe-button--selected": {
        " .pe-button__focus": {
          opacity: componentVars["color_" + tint + "_focus_opacity"],
          backgroundColor: "currentcolor"
        }
      },

      ".pe-button--disabled": {
        color: componentVars["color_" + tint + "_disabled"]
      }
    })];
  };

  var noTouchStyle = function noTouchStyle(scopes, selector, componentVars, tint) {
    return [_defineProperty$1({}, scopes.map(function (s) {
      return s + selector + ":hover";
    }).join(","), {
      " .pe-button__wash": {
        backgroundColor: componentVars["color_" + tint + "_wash"]
      }
    })];
  };

  var color = (function (selector, componentVars) {
    return [style([".pe-dark-tone", ".pe-dark-tone "], selector, componentVars, "dark"), // has/inside dark tone
    style(["", ".pe-light-tone", ".pe-light-tone "], selector, componentVars, "light"), // normal, has/inside light tone
    noTouchStyle(["html.pe-no-touch .pe-dark-tone "], selector, componentVars, "dark"), // inside dark tone
    noTouchStyle(["html.pe-no-touch ", "html.pe-no-touch .pe-light-tone "], selector, componentVars, "light")];
  });

  var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

  var fns = [layout, color];
  var selector = "." + classes.component.replace(/ /g, ".");

  var addStyle = function addStyle(customSelector, customVars) {
    return polytheneCoreCss.styler.generateStyles([customSelector, selector], _extends({}, polytheneCoreIconButton.vars, customVars), fns);
  };

  var getStyle = function getStyle(customSelector, customVars) {
    return customSelector ? polytheneCoreCss.styler.createStyleSheets([customSelector, selector], _extends({}, polytheneCoreIconButton.vars, customVars), fns) : polytheneCoreCss.styler.createStyleSheets([selector], polytheneCoreIconButton.vars, fns);
  };

  polytheneCoreCss.styler.generateStyles([selector], polytheneCoreIconButton.vars, fns);

  exports.addStyle = addStyle;
  exports.getStyle = getStyle;

  Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=polythene-css-icon-button.js.map
